﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.Text;
using System.Threading;

namespace VideoServer
{
    [ServiceBehavior(ConcurrencyMode = ConcurrencyMode.Multiple, InstanceContextMode = InstanceContextMode.PerSession)]
    public class VideoConferenceService : IVideoConferenceService
    {
        private ReaderWriterLockSlim subscribersLock = new ReaderWriterLockSlim();
        private static List<IVideoConferenceServiceCallback> subscribers = new List<IVideoConferenceServiceCallback>();

        public void Subscribe()
        {
            try
            {
                subscribersLock.EnterWriteLock();
                subscribers.Add(OperationContext.Current.GetCallbackChannel<IVideoConferenceServiceCallback>());
            }
            finally
            {
                subscribersLock.ExitWriteLock();
            }
        }

        public void Publish(byte[] data)
        {
            try
            {
                subscribersLock.EnterReadLock();
                foreach (var subscriber in subscribers)
                {
                    subscriber.OnData(data);
                }
            }
            finally
            {
                subscribersLock.ExitReadLock();
            }
        }
    }
}
